#include <stdio.h>
#include <stdlib.h>
#include "jmemdstsrc.h"
/*
 Initialize source --- Nothing to do
 */
METHODDEF(void)
init_source (j_decompress_ptr cinfo)
{}


/*
 Fill the input buffer --- called whenever buffer is emptied.
 */
METHODDEF(boolean)
fill_input_buffer (j_decompress_ptr cinfo)
{
	my_src_ptr src = (my_src_ptr) cinfo->src;

	src->pub.next_input_byte = src->buffer;
	src->pub.bytes_in_buffer = src->bufsize;

	return TRUE;
}

/*
 Skip data --- used to skip over a potentially large amount of
 uninteresting data.
 */
METHODDEF(void)
skip_input_data (j_decompress_ptr cinfo, long num_bytes)
{
	my_src_ptr src = (my_src_ptr) cinfo->src;

	/* just move the ptr */
	src->pub.next_input_byte += num_bytes;
	src->pub.bytes_in_buffer -= num_bytes;
}

/*
  Terminate source --- called by jpeg_finish_decompress
 */
METHODDEF(void)
term_source (j_decompress_ptr cinfo)
{}

/*
 Prepare for input from a memory buffer.
 */
GLOBAL(void)
jpeg_mem_src (j_decompress_ptr cinfo, unsigned char* buffer, unsigned int bufsize)
{
	my_src_ptr src;

	if (cinfo->src == NULL) {
		cinfo->src = (struct jpeg_source_mgr *)
		(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,  sizeof(my_source_mgr));
  }

	src = (my_src_ptr) cinfo->src;
	src->pub.init_source = init_source;
	src->pub.fill_input_buffer = fill_input_buffer;
	src->pub.skip_input_data = skip_input_data;
	src->pub.resync_to_restart = jpeg_resync_to_restart; 
	src->pub.term_source = term_source;
	src->pub.bytes_in_buffer = 0; 
	src->pub.next_input_byte = NULL; 

	src->buffer = buffer;
	src->bufsize = bufsize;
}

