#include "TePDIMosaic.hpp"
#include "TePDIMosaicStratFactory.hpp"
#include "TePDIAgnostic.hpp"


TePDIMosaic::TePDIMosaic()
{
}


TePDIMosaic::~TePDIMosaic()
{
}


void TePDIMosaic::ResetState( const TePDIParameters& params )
{
  TePDIParameters dummy_params = params;
}


bool TePDIMosaic::CheckParameters( const TePDIParameters& parameters ) const
{
  std::string mosaic_type;
  PDIAGN_TRUE_OR_RETURN( parameters.GetParameter( "mosaic_type", mosaic_type ),
    "Missing parameter : mosaic_type" );

  TePDIMosaicStrategy::pointer mosaic_strategy(  
    TePDIMosaicStratFactory::make( mosaic_type, parameters ) );
    
  PDIAGN_TRUE_OR_RETURN( mosaic_strategy.isActive(), "Invalid strategy" );
  
  return mosaic_strategy->CheckParameters( parameters );
}


bool TePDIMosaic::RunImplementation()
{
  std::string mosaic_type;
  PDIAGN_TRUE_OR_RETURN( params_.GetParameter( "mosaic_type", mosaic_type ),
    "Missing parameter : mosaic_type" );
    
  TePDIMosaicStrategy::pointer mosaic_strategy(  
    TePDIMosaicStratFactory::make( mosaic_type, params_ ) );
    
  PDIAGN_TRUE_OR_RETURN( mosaic_strategy.isActive(), "Invalid strategy" );
  
  return mosaic_strategy->Apply( params_ );
}

