#include "TePDISegmentation.hpp"
#include "TePDIStrategyFactory.hpp"
#include "TePDIAgnostic.hpp"


TePDISegmentation::TePDISegmentation()
{
}


TePDISegmentation::~TePDISegmentation()
{
}


void TePDISegmentation::ResetState( const TePDIParameters& params )
{
  TePDIParameters dummy_params = params;
}


bool TePDISegmentation::CheckParameters( 
  const TePDIParameters& parameters ) const
{
  std::string segmentation_type;
  PDIAGN_TRUE_OR_RETURN( parameters.GetParameter( "segmentation_type", 
    segmentation_type ), "Missing parameter : segmentation_type" );

  TePDIStrategy::pointer segmentation_strategy(  
    TePDIStrategyFactory::make( segmentation_type, parameters ) );
    
  PDIAGN_TRUE_OR_RETURN( segmentation_strategy.isActive(), 
    "Invalid strategy" );
  
  return segmentation_strategy->CheckParameters( parameters );
}


bool TePDISegmentation::RunImplementation()
{
  std::string segmentation_type;
  PDIAGN_TRUE_OR_RETURN( params_.GetParameter( "segmentation_type", 
    segmentation_type ), "Missing parameter : segmentation_type" );
    
  TePDIStrategy::pointer segmentation_strategy(  
    TePDIStrategyFactory::make( segmentation_type, params_ ) );
    
  PDIAGN_TRUE_OR_RETURN( segmentation_strategy.isActive(), 
    "Invalid strategy" );
  
  return segmentation_strategy->Apply( params_ );
}

