 
#include "TePDISegmentationFactory.hpp"
#include "TePDISegmentation.hpp"
#include "TePDIAgnostic.hpp"


TePDISegmentationFactory::TePDISegmentationFactory()
: TePDIAlgorithmFactory( std::string( "TePDISegmentation" ) )
{
};      


TePDISegmentationFactory::~TePDISegmentationFactory()
{
};


TePDIAlgorithm* TePDISegmentationFactory::build ( const TePDIParameters& arg )
{
  TePDIAlgorithm* instance_ptr = new TePDISegmentation();
  
  PDIAGN_TRUE_OR_THROW( instance_ptr->Reset( arg ),
    "Invalid parameters" );
  
  return instance_ptr;
}
