 
#include "TePDIWaveletsFactory.hpp"
#include "TePDIWavelets.hpp"
#include "TePDIAgnostic.hpp"


TePDIWaveletsFactory::TePDIWaveletsFactory()
: TePDIAlgorithmFactory( std::string( "TePDIWavelets" ) )
{
};      


TePDIWaveletsFactory::~TePDIWaveletsFactory()
{
};


TePDIAlgorithm* TePDIWaveletsFactory::build ( const TePDIParameters& arg )
{
  TePDIAlgorithm* instance_ptr = new TePDIWavelets();
  
  PDIAGN_TRUE_OR_THROW( instance_ptr->Reset( arg ),
    "Invalid parameters" );
  
  return instance_ptr;
}
